package com.steerinfo.metermonitor.metermonitornote.controller;

import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.metermonitor.metermonitornote.model.MeterMonitorNote;
import com.steerinfo.metermonitor.metermonitornote.service.IMeterMonitorNoteService;
import com.steerinfo.meterwork.except.MarkerMetException;
import com.steerinfo.meterwork.meterworkmonitor.model.MeterWorkMonitor;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Arrays;
import java.util.Date;
import java.util.HashMap;
import java.util.List;

/**
 * MeterMonitorNote RESTful接口：
 *
 * @author generator
 * @version 1.0-SNAPSHORT 2020-09-22 07:12
 * 类描述
 * 修订历史：
 * 日期：2020-09-22
 * 作者：generator
 * 参考：
 * 描述：MeterMonitorNote RESTful接口
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 * @see null
 */
@RestController
@RequestMapping("/${api.version}/metermonitornotes")
public class MeterMonitorNoteController extends BaseRESTfulController {

    @Autowired
    IMeterMonitorNoteService meterMonitorNoteService;

    @ApiOperation(value = "获取列表", notes = "分页查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("metermonitornote:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        try {
            PageList<MeterMonitorNote> list = meterMonitorNoteService.likeByDesc(parmas, pageNum, pageSize);
            return success(list);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "获取列表", notes = "分页模糊查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("metermonitornote:view")
    @GetMapping(value = "/likeByDesc")
    public RESTfulResult likeByDesc(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        try {
            PageList<MeterMonitorNote> list = meterMonitorNoteService.likeByDesc(parmas, pageNum, pageSize);
            return success(list);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "获取列表", notes = "分页模糊查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("metermonitornote:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        try {
            PageList<MeterMonitorNote> list = meterMonitorNoteService.queryLikeForPage(parmas, pageNum, pageSize);
            return success(list);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "创建", notes = "根据MeterMonitorNote对象创建")
    @ApiImplicitParam(name = "meterMonitorNote", value = "详细实体meterMonitorNote", required = true, dataType = "MeterMonitorNote")
    //@RequiresPermissions("metermonitornote:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@ModelAttribute MeterMonitorNote model) {
        try {
            MeterMonitorNote meterMonitorNote = meterMonitorNoteService.add(model);
            return success(meterMonitorNote);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "获取详细信息", notes = "根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("metermonitornote:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id) {
        try {
            MeterMonitorNote meterMonitorNote = meterMonitorNoteService.getById(id);
            return success(meterMonitorNote);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "更新详细信息", notes = "根据url的id来指定更新对象，并根据传过来的meterMonitorNote信息来更新详细信息")
    @ApiImplicitParams({
            @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
            @ApiImplicitParam(name = "meterMonitorNote", value = "详细实体meterMonitorNote", required = true, dataType = "MeterMonitorNote")
    })
    //@RequiresPermissions("metermonitornote:update")
    @PutMapping(value = "/{id}", produces = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody MeterMonitorNote model) {
        try {
            model.setId(id);
            model.setUpdateTime(new Date());
            MeterMonitorNote meterMonitorNote = meterMonitorNoteService.modify(model);
            return success(meterMonitorNote);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "删除", notes = "根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("metermonitornote:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id) {
        try {
            List<String> list = Arrays.asList(id.split(","));
            if (ListUtils.isNotEmpty(list)) {
                List<String> ids = ListUtils.convertList(list);
                meterMonitorNoteService.delete(ids);
            }
            return success();
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "条件查询历史视图", notes = "根据传入参数进行查询")
    @GetMapping(value = "/selectView")
    public RESTfulResult selectView(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        RESTfulResult rm = failed();
        try {
            PageList<MeterMonitorNote> list = meterMonitorNoteService.selectView(parmas, pageNum, pageSize);
            return success(list);
        } catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！");
        } finally {

        }
        return rm;
    }

    @ApiOperation(value = "计量场景还原查询", notes = "根据传入参数进行查询")
    @GetMapping(value = "/selectByTime")
    public RESTfulResult selectByTime(@RequestParam String baseSpotNo, String operationTime, String carNo, Integer pageNum, Integer pageSize) {
        RESTfulResult rm = failed();
        try {
            PageList<MeterMonitorNote> list = meterMonitorNoteService.selectByTime(baseSpotNo, operationTime, carNo, pageNum, pageSize);
            return success(list);
        } catch (MarkerMetException e) {
            e.printStackTrace();
            rm.setMessage(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！");
        } finally {

        }
        return rm;
    }

    @ApiOperation(value = "创建", notes = "根据MeterMonitorNote对象创建")
    @ApiImplicitParam(name = "meterMonitorNote", value = "详细实体meterMonitorNote", required = true, dataType = "MeterMonitorNote")
    //@RequiresPermissions("metermonitornote:create")
    @PostMapping(value = "/doSaveWf")
    public RESTfulResult doSaveWf(@RequestBody MeterMonitorNote model) {
        try {
            String id = meterMonitorNoteService.doSaveWf(model);
            return success(id);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }


    @ApiOperation(value = "区分汽车衡和火车衡的操作日志以及智能终端操作日志", notes = "根据传入参数进行查询")
    @GetMapping(value = "/selectByType")
    public RESTfulResult selectByType(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        RESTfulResult rm = failed();
        try {
            PageList<MeterMonitorNote> list = meterMonitorNoteService.selectByType(parmas, pageNum, pageSize);
            return success(list);
        } catch (MarkerMetException e) {
            e.printStackTrace();
            rm.setMessage(e.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！");
        } finally {

        }
        return rm;
    }

    @ApiOperation(value = "获取列表", notes = "不分页模糊查询最新前100条记录")
    @GetMapping(value = "/noPage")
    public RESTfulResult noPage(@RequestParam HashMap parmas) {
        try {
            List<MeterMonitorNote> list = meterMonitorNoteService.queryLikeNoPage(parmas);
            return success(list);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "获取列表", notes = "分页模糊查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    @GetMapping(value = "/allStateView/")
    public RESTfulResult allStateView(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        try {
            PageList<MeterMonitorNote> list = meterMonitorNoteService.allStateView(parmas, pageNum, pageSize);
            return success(list);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }
    @ApiOperation(value = "获取列表", notes = "分页模糊查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    @GetMapping(value = "/resetCarView/")
    public RESTfulResult resetCarView(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        try {
            PageList<MeterMonitorNote> list = meterMonitorNoteService.resetCarView(parmas, pageNum, pageSize);
            return success(list);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }
}
